
#include <dinput.h>
#include <windows.h>
#include "key.h"

static LPDIRECTINPUTDEVICE lpJoyDev[4];
static int lpJoyDevNum;


MDInput::MDInput(LPDIRECTINPUT di, HINSTANCE hi, HWND hw){
	lpDInput=di;
	hwnd = hw;
	hinst = hi;
	lpJoyDevNum=0;
	lpDIKeyDev=NULL;
	lpDIJoyDev[0]=NULL;
	lpDIJoyDev[1]=NULL;
	lpDIJoyDev[2]=NULL;
	lpDIJoyDev[3]=NULL;
	lpDIJoyDev2[0]=NULL;
	lpDIJoyDev2[1]=NULL;
	lpDIJoyDev2[2]=NULL;
	lpDIJoyDev2[3]=NULL;
	InitKeyboard();
	InitJoystick();
}


MDInput::~MDInput(){
	if(lpDIKeyDev!=NULL){
        lpDIKeyDev->Unacquire();
        lpDIKeyDev->Release();
        lpDIKeyDev=NULL;
	}
	for(int i=0; i<4; ++i){
		if(lpDIJoyDev2[i]!=NULL){
	        lpDIJoyDev2[i]->Unacquire();
	        lpDIJoyDev2[i]->Release();
	        lpDIJoyDev2[i]=NULL;
		}
		if(lpDIJoyDev[i]!=NULL){
		    lpDIJoyDev[i]->Unacquire();
		    lpDIJoyDev[i]->Release();
		    lpDIJoyDev[i]=NULL;
		}
	}
/*	if(lpDInput!=NULL){
		lpDInput->Release();
		lpDInput=NULL;
	}*/
}


static BOOL CALLBACK InitJoystickInput(LPCDIDEVICEINSTANCE pdInst,LPVOID pvRef){
	LPDIRECTINPUT pdi=(LPDIRECTINPUT)pvRef;

	if(lpJoyDevNum>=4)
		return DIENUM_STOP;
	if(pdi->CreateDevice(pdInst->guidInstance,&lpJoyDev[lpJoyDevNum],NULL)!=DI_OK){
		lpJoyDev[lpJoyDevNum]=NULL;
		++lpJoyDevNum;
		return DIENUM_CONTINUE;
	}
	if(lpJoyDev[lpJoyDevNum]->SetDataFormat(&c_dfDIJoystick)!=DI_OK){
		lpJoyDev[lpJoyDevNum]->Release();
		lpJoyDev[lpJoyDevNum]=NULL;
		++lpJoyDevNum;
		return DIENUM_CONTINUE;
	}
	++lpJoyDevNum;
	return DIENUM_CONTINUE;
}


BOOL MDInput::InitJoystick(){
	HRESULT ret;

	ret=lpDInput->EnumDevices(DIDEVTYPE_JOYSTICK,InitJoystickInput,lpDInput,DIEDFL_ATTACHEDONLY);
	if(ret!=DI_OK) return FALSE;

	DIPROPRANGE di;
	for(int i=0; i<4; ++i){
		lpDIJoyDev[i] = lpJoyDev[i];
		if(lpDIJoyDev[i]==NULL)
			break;
/*		ret=lpDIJoyDev[i]->SetCooperativeLevel(hwnd, DISCL_EXCLUSIVE/* | DISCL_BACKGROUND | DISCL_FOREGROUND /* DISCL_NONEXCLUSIVE );
		if(ret!=DI_OK){
			lpDIJoyDev[i]->Release();
			lpDIJoyDev[i]=NULL;
			return FALSE;
		}
*/		ret=lpDIJoyDev[i]->QueryInterface(IID_IDirectInputDevice2,(LPVOID *)&lpDIJoyDev2[i]);
		if(ret!=DI_OK){
			lpDIJoyDev[i]->Release();
			lpDIJoyDev[i]=NULL;
			return FALSE;
		}

		di.diph.dwSize=sizeof(DIPROPRANGE);
		di.diph.dwHeaderSize=sizeof(di.diph); 
		di.diph.dwObj=DIJOFS_X; 

		di.diph.dwHow=DIPH_BYOFFSET; 
		di.lMin=-127; 
		di.lMax=+127;
		lpDIJoyDev[i]->SetProperty(DIPROP_RANGE,&di.diph);
		di.diph.dwObj=DIJOFS_Y; 
		di.diph.dwHow=DIPH_BYOFFSET; 
		di.lMin=-127; 
		di.lMax=+127;
		lpDIJoyDev[i]->SetProperty(DIPROP_RANGE,&di.diph);
		lpDIJoyDev[i]->Acquire();
	}
	return TRUE;
}


BOOL MDInput::InitKeyboard(){
	HRESULT ret;

	ret=lpDInput->CreateDevice(GUID_SysKeyboard,&lpDIKeyDev,NULL);
	if(ret!=DI_OK) return FALSE;
	ret=lpDIKeyDev->SetDataFormat(&c_dfDIKeyboard);
	if(ret!=DI_OK){
		lpDIKeyDev->Release();
		lpDIKeyDev=NULL;
		return FALSE;
	}
/*	ret=lpDIKeyDev->SetCooperativeLevel(hwnd, DISCL_NONEXCLUSIVE | DISCL_FOREGROUND);
	if(ret!=DI_OK){
		lpDIKeyDev->Release();
		lpDIKeyDev=NULL;
		return FALSE;
	}
*/	lpDIKeyDev->Acquire();
	return TRUE;
}


BOOL MDInput::PollKeyState(unsigned char *kc){
	DIJOYSTATE js;
	BYTE diks[256];
	HRESULT ret;
	int jn;

	ZeroMemory(kc, 4);
	ZeroMemory(diks, sizeof(diks));
	if(lpDIKeyDev!=NULL){
		kc[3]=1;
		ret=lpDIKeyDev->GetDeviceState(sizeof(diks),&diks);
		if(ret==DIERR_INPUTLOST){
			ret=lpDIKeyDev->Acquire();
			if(ret==DI_OK)
				ret=lpDIKeyDev->GetDeviceState(sizeof(diks),&diks);
		}
		if(ret==DI_OK){
			for(jn=0; jn<256;++jn){
				if(diks[jn] & 0x80){
					kc[0]=1,kc[1]=0;
					kc[2]=(unsigned char)jn;
					return TRUE;
				}
			}
		}
	}

	//Joystick
	for(jn=0; jn<4; ++jn){
		if(lpDIJoyDev[jn]==NULL)
			continue;
		lpDIJoyDev2[jn]->Poll();
		ret=lpDIJoyDev[jn]->GetDeviceState(sizeof(DIJOYSTATE),&js);
		if(ret==DIERR_INPUTLOST){
			lpDIJoyDev[jn]->Acquire();
			continue;
		}
		if(ret!=DI_OK)
			continue;
		if(js.lX<-64){		//left
			kc[0]=2,kc[1]=jn;
			kc[2]=0;
			return TRUE;
		}
		if(js.lX>64){		//right
			kc[0]=2,kc[1]=jn;
			kc[2]=1;
			return TRUE;
		}
		if(js.lY<-64){		//down
			kc[0]=2,kc[1]=jn;
			kc[2]=2;
			return TRUE;
		}
		if(js.lY>64){		//up
			kc[0]=2,kc[1]=jn;
			kc[2]=3;
			return TRUE;
		}
		for(int bn=0; bn<32;++bn){
			if(js.rgbButtons[bn] & 0x80){
				kc[0]=2,kc[1]=jn;
				kc[2]=bn+4;
				return TRUE;
			}
		}
	}
	return TRUE;
}

