
#include <windows.h>
#include <shlwapi.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define UNZ_BUFSIZE (65536)

#include "unzip.h"
#include "ulunzip.h"

extern int MystrCmp(char *,char *);


int UseUnzipLibExeLoad(char *fn, unsigned char **buff, unsigned long *ucsize){
	uLong i;
	unz_global_info gi;
	int err;
	unzFile uf=NULL;
	char filename_inzip[256], *extp;
	unz_file_info file_info;

	uf = unzOpen(fn);
	if(uf==NULL)
		return 0;
	err = unzGetGlobalInfo (uf,&gi);
	if(err!=UNZ_OK)
		return 0;
	for (i=0;i<gi.number_entry;i++){
		err = unzGetCurrentFileInfo(uf,&file_info,filename_inzip,sizeof(filename_inzip),NULL,0,NULL,0);
		if(err!=UNZ_OK)
			break;
		extp=PathFindExtension(filename_inzip);
		++extp;
		if(MystrCmp(extp, "nes") || MystrCmp(extp, "fds") || MystrCmp(extp, "fam") || MystrCmp(extp, "nsf")){
			*ucsize = file_info.uncompressed_size;
			*buff = (unsigned char *)malloc(file_info.uncompressed_size);
			if(buff==NULL)
				break;
			err = unzOpenCurrentFile(uf);
			if(err!=UNZ_OK)
				break;
			err = unzReadCurrentFile(uf, *buff, file_info.uncompressed_size);
			unzCloseCurrentFile(uf);
			if((unsigned int)err != file_info.uncompressed_size){
				free(buff);
				return 0;
			}
			return 1;
		}
		if ((i+1)<gi.number_entry){
			err = unzGoToNextFile(uf);
			if (err!=UNZ_OK){
				break;
			}
		}
	}
	unzCloseCurrentFile(uf);
	return 0;
}









