
#include "win32_INPButtons.h"
#include "win32_EXT_key.h"
#include "nnnextkeycfg.h"

win32_EXT_key::win32_EXT_key(OSD_ButtonSettings* btnsettings, win32_directinput_input_mgr* inp_mgr)
{
	for(int i=0; i<EXTKEYALLNUM; ++i){
		ExtButton[i] = NULL;
		Buttonp[i]=0;
		Buttonf[i]=0;
	}
  CreateButtons(btnsettings, inp_mgr);
}

win32_EXT_key::~win32_EXT_key()
{
  DeleteButtons();
}

void win32_EXT_key::Poll()
{
	for(int i=0; i<EXTKEYALLNUM; ++i){
		if(ExtButton[i] == NULL)
			continue;
		if(!Buttonp[i]){
			if(Buttonf[i]==0){
				if(ExtButton[i]->Pressed()){
					Buttonp[i]=1;
					Buttonf[i]=1;
				}
			}
			else{
				if(!ExtButton[i]->Pressed()){
					Buttonp[i]=2;
					Buttonf[i]=0;
				}
			}
		}
	}
}

INPButton* win32_EXT_key::CreateButton(OSD_ButtonSettings* settings, win32_directinput_input_mgr* inp_mgr)
{
  INPButton* button;

  button = GetINPButton(settings, inp_mgr);
  if(!button) throw "Error allocating INPButton";

  return button;
}

void win32_EXT_key::CreateButtons(OSD_ButtonSettings* bsettings, win32_directinput_input_mgr* inp_mgr)
{
  DeleteButtons();
  try {
	  for(int i=0; i<EXTKEYALLNUM; ++i){
		  ExtButton[i] = CreateButton(&bsettings[i], inp_mgr);
	  }
  } catch(...) {
    DeleteButtons();
    throw;
  }
}

#define DELETEBUTTON(ptr) \
  if(ptr) delete ptr; \
  ptr = NULL;

void win32_EXT_key::DeleteButtons()
{
	for(int i=0; i<EXTKEYALLNUM; ++i){
		DELETEBUTTON(ExtButton[i]);
	}
}


